/*
 * USE - UML based specification environment
 * Copyright (C) 1999-2004 Mark Richters, University of Bremen
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

// $Id: DirectedEdge.java 61 2008-04-11 11:52:15Z opti $

package org.tzi.use.graph;

/** 
 * Basic interface of directed binary edges in a graph.
 *
 * @version     $ProjectVersion: 0.393 $
 * @author  Mark Richters
 * @see     DirectedGraph
 */


public interface DirectedEdge {

    /**
     * Returns the source node of this edge.
     */
    Object source();

    /**
     * Returns the target node of this edge.
     */
    Object target();

    /**
     * Returns true if source and target of this edge connect the same Node.
     */
    boolean isReflexive();
}
